/*
 * Demo for Maker Faire Tokyo
 * loovee 
 * 2015-7-15
 */

#include <LED_Matrix.h>
#include <LED_Matrix_dfs.h>
#include <MsTimer2.h>


// you can change your name here
char __name[] = "Maker Faire Tokyo ";



int speed   = 1;
int btn_flg = 0;

int pin_btn = 2;

int BTN_ON = 0;


const int delay_time[5] = {900, 800, 700, 600, 500};

// matrix of big heart
unsigned char big_heart[8] = {

0b00000000,
0b01100110,
0b11111111,
0b11111111,
0b11111111,
0b01111110,
0b00111100,
0b00011000,
};

// matrix of small heart
unsigned char small_heart[8] = {

0b00000000,
0b00000000,
0b00100100,
0b01111110,
0b01111110,
0b00111100,
0b00011000,
0b00000000,
};


void speedCnt()
{
    speed++;
    if(speed>4)speed = 0;
    
    Serial.print("speed = ");
    Serial.println(speed);
}


// matrix of empty
unsigned char empty[8] = {0, 0, 0, 0, 0, 0, 0, 0};

/*
 * delay ms until the button is pressed
 */
void checkBtnAndDelay(int ms)
{
    
    if(btn_flg)return;
    
    unsigned long timer_c = millis();
    while(1)
    {
        if(millis()-timer_c >= ms)return;
        
        if(digitalRead(pin_btn) == BTN_ON)
        {
            Serial.print("#");
            delay(20);
            if(digitalRead(pin_btn) == BTN_ON)
            {
                
                speedCnt();
                matrix.dispChar('0'+1+speed);
                
                Serial.println("button on");
                btn_flg = 1;
                
                for(int i=0; i<20; i++)
                while(digitalRead(pin_btn) == BTN_ON);
            
                Serial.println("button pressed");
                matrix.clear();
                return;
            }
        }
    }
}


#define __delay checkBtnAndDelay

void heart(int d, int ms)
{
    if(0 == d)                  // empty
    {
        matrix.dispMatrix(empty);
        __delay(ms);
    }
    else if(1 == d)             // small heart
    {
        matrix.dispMatrix(small_heart);
        __delay(ms);
    }
    else if(2 == d)
    {
        matrix.dispMatrix(big_heart);
        __delay(ms);
    }
    
    switch(d)
    {
        case 0:
        matrix.dispMatrix(empty);
    }
}

void heart()
{
    int d1[] = {1, 0, 1, 2, 1, 0};
    int d2[] = {200, 250, 100, 200, 100, 500};
    for(int i=0; i<6; i++)heart(d1[i], d2[i]);

}


void setup()
{
    matrix.begin(DIR_NORMAL);
    Serial.begin(115200);

    pinMode(pin_btn, INPUT);
    BTN_ON = 1-digitalRead(pin_btn);
    
    matrix.dispString(STR_ONCE, 800, "Seeed");
}


void loop()
{
    heart();
    
    if(btn_flg)
    {
        btn_flg = 0;
        matrix.clear(); 
        
    }
    
    matrix.dispString(STR_ONCE, delay_time[speed], __name);
}
